#!/bin/sh
# $Id: skel.vxrsyncd.sh,v 2.17.2.3 2009/05/07 18:51:33 vraichur Exp $
#ident "$Source: /project/vras-cvs/src/linux/cmd/vras/init.d/skel.vxrsyncd.sh,v $ $Revision: 2.17.2.3 $"
#
# $Copyright: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#

### BEGIN INIT INFO
# Provides: vxrsyncd
# Should-Start:
# Required-Start: vxvm-boot
# Required-Stop:
# Default-Start:  2 3 4 5
# Default-Stop:
# Description:
### END INIT INFO

# Volume Replicator Administrative Services (VRAS) Daemon Script 
# start up / shut down in.vxrsyncd daemon
# Starts in.vxrsyncd daemon only if VVR license is installed

if [ ! -d /usr/sbin ]
then                    # /usr not mounted
	echo "/usr not mounted"
	quit
fi

. ${VOLADM_LIB:-/usr/lib/vxvm/voladm.d/lib}/vxadm_lib.sh

progname=$0
daemon="in.vxrsyncd"

#
# All environment variables used by in.vxrsyncd are defined in this file
#
ENVFILE=/etc/vx/vras/vras_env

findproc() {        # return pid of the named process(es)
	pid=`/bin/ps -e -o pid,comm |
		 /bin/grep " $1" | /bin/grep -v grep |
		 /bin/awk '{ print $1 }'`
}

check_vvr_license() {       # return 0 if has vvr license
                            # and return 1 otherwise
	/sbin/vxlictest -n "VERITAS Volume Manager" -f "VVR" >/dev/null 2>&1
	if [ "$?" -eq 0 ]; then
		return 0
	else
		return 1
	fi
}

case "$1" in
'start')		
	# check for vvr license
	/sbin/vxlictest -n "VERITAS Volume Manager" -f "VVR" >/dev/null 2>&1
	if [ $? != 0 ]; then
		#initlog -n "VxRSyncd daemon" -s "N/A"
		export dname=VxRSyncd; ugettxt -n "VVR" "$dname daemon              N/A" vras.mesg:2414
		quit 1
	fi

	# make sure file install-db does not exist
	if [ -f /etc/vx/reconfig.d/state.d/install-db ]; then
		export daemon; ugettxt -n "VVR" -s "INFO" \
			"VM installation not complete; $daemon not started." vras.mesg:2410
		quit 1
	fi

	# check if in.vxrsyncd is already running
	findproc in.vxrsyncd;
	if [ "X$pid" != "X" ]; then
		quit 0
	fi

	# source the environment variables defined in ENVFILE
	if [ -f ${ENVFILE} ]; then
		. ${ENVFILE}
	fi

	# Start VxRSync daemon
	/usr/sbin/in.vxrsyncd
	#initlog -n "VxRSyncd  daemon" -s "Started"
	export dname=VxRSyncd; ugettxt -n "VVR" "Starting $dname daemon: [  OK  ]" vras.mesg:2415
	;;
'stop')
	findproc in.vxrsyncd;
	if [ "X$pid" != "X" ]; then
		/bin/kill -15 $pid
	fi
	;;
'restart')
	$0 stop
	$0 start
	;;
*)
	export progname; ugettxt -n "VVR" -s "INFO" \
			"Usage: $progname { start | stop | restart }" vras.mesg:0
	quit 1
	;;
esac

quit 0
