#$Id: sendTrap.pl,v 1.8 2006/03/28 13:30:52 adongre Exp $ 
#$Copyright: Copyright (c) 2009 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $ 

#use Net::SNMP qw(:ALL); 
use Net::SNMP;
$trap_template_file=$ARGV[0];

my $community         = "";
my $hostname           = "";
my @oidvalues;

open(FILE,$trap_template_file)||die("Could not open file");


my $timeticks = time();
push ( @oidvalues, '1.3.6.1.2.1.1.3.0');
push ( @oidvalues, TIMETICKS);
push ( @oidvalues, $timeticks);



push ( @oidvalues, '1.3.6.1.6.3.1.1.4.1.0');
push ( @oidvalues, OBJECT_IDENTIFIER);

my $temp_identifier;

while ( <FILE> )
{
   if ( index ($_, "OID_VALUES" ) >= 0 )
   {
       @array=split(/=/);
       $temp_identifier  = $array[1];
       my @arr = split /,/ , $temp_identifier;
       $arr[0] =~ s/\.[0-9]+$//g;
       push ( @oidvalues, $arr[0]);
       last;
   }
}
close FILE;

open(FILE,$trap_template_file)||die("Could not open file");

while ( <FILE> )
{
   if ( index ( $_, "COMMUNITY") >= 0 )
   {
       @array=split(/=/);
       $community = @array[1];
       chop($community)
   }
   if ( index ( $_, "DESTINATION_HOST") >= 0 )
   {
       @array = split(/=/);
       $hostname= $array[1];
       chop( $hostname );
   }    
   if ( index ($_, "OID_VALUES" ) >= 0 )
   {
       @array = split(/=/);
       $varbind_value  = $array[1];
       chomp($varbind_value);
       $_ = $varbind_value;
       @varbind_array = split(/,/);

       if ( $varbind_array[0] ne "")	 
       {
          if ( $varbind_array[1] ne "")	 
          { 
             if ( $varbind_array[2] ne "")	 
             {
                  push ( @oidvalues, $varbind_array[0]);
                  push ( @oidvalues, $varbind_array[1]);
                  push ( @oidvalues, $varbind_array[2]);
             }
          }
       }
   }
}
close FILE;

my ($session, $error) = Net::SNMP->session(
   -hostname  => $hostname,
   -community => $community,
   -port      => 162,      # Need to use port 162 
   -version   => 'snmpv2c'

);

if (!defined($session)) {  
printf("ERROR: %s.\n", $error);  
exit 1;
}

my $sysUpTime = '1.3.6.1.2.1.1.3.0';


$result = $session->snmpv2_trap(
    -varbindlist => \@oidvalues,
);


if (!defined($result)) {
   printf("ERROR: %s.\n", $session->error());
} else {
   printf("SUCCESS");
}

$session->close();
exit (0);

