#!/bin/sh
# $Id
# $Copyright

# Define keys


JUMPSTART_PATH="/"
if [ "X$PKG_INSTALL_ROOT" != "X" ]
then
    JUMPSTART_PATH="$PKG_INSTALL_ROOT"
fi


PALVERSION=pal33
AGENT_NAME=actionagent


REGFILE="$PKG_INSTALL_ROOT/etc/vx/isis/Registry"
REGOPS="$PKG_INSTALL_ROOT/opt/VRTSobc/$PALVERSION/bin/vxregctl"
VEACONFIG=$PKG_INSTALL_ROOT/opt/VRTSobc/pal33/bin/veaconfig

OBC_INSTALLPATH="$PKG_INSTALL_ROOT/opt/VRTSobc"
AGENT_INSTALLPATH="$PKG_INSTALL_ROOT/opt/VRTSaa"
OS=`uname -a`
AGENTS=Software/VERITAS/VRTSobc/$PALVERSION/Agents

VXAA_ETC="$PKG_INSTALL_ROOT/opt/VRTSaa/etc"
VXAA_DIR="$PKG_INSTALL_ROOT/opt/VRTSaa"


CE_ID={b0c6307c-d11e-46a8-8a33-82b599c20ee9}
MSGCAT_ID={3ddcb6cc-1dd2-11b2-bfb0-0003ba43f9b9}
HELP_ID={49f48010-1dd2-11b2-8433-0003ba919e6d}


leavedomDRD()
{
    msg NOTE "The vxsvc will be informed that the actionagent is no longer available when the inactive system image is booted.."
    initfile=/sbin/init.d/xaarcdrdLEAVE
    rcfile=/sbin/rc2.d/S999xaarcdrdLEAVE
    rm -rf $rcfile $initfile

    print "#!/sbin/sh" > $initfile
    print "$VEACONFIG -c leavedc -a actionagent -u vea_agent@vea_domain.vx --no-prompt"  >> initfile
    print "/usr/bin/rm -rf $initfile $rcfile " >> $initfile
    print "    exit \$? "  >> $initfile

    chmod 555 $initfile
    chown bin:bin $initfile
    ln -s $initfile $rcfile

}

leavedom()
{
  $VEACONFIG -b $JUMPSTART_PATH -c leavedc -a actionagent --no-prompt 2>/dev/null

  SECKEY=Software/VERITAS/VRTSobc/$PALVERSION/Agents/__defaults/Network/Params/Security

  q_hostname=`$OBC_INSTALLPATH/$PALVERSION/bin/vxregctl $REGFILE queryvalue $SECKEY LocalSystem 2>/dev/null`
  q_dc=`$OBC_INSTALLPATH/$PALVERSION/bin/vxregctl $REGFILE queryvalue $SECKEY DomainController 2>/dev/null`
  q_ab=`$OBC_INSTALLPATH/$PALVERSION/bin/vxregctl $REGFILE queryvalue $SECKEY AuthenticationBroker 2>/dev/null`

  hostname=`echo $q_hostname |sed -e 's/^.*: //g'`
  dc=`echo $q_dc |sed -e 's/^.*: //g'`

  $VEACONFIG -b $JUMPSTART_PATH -c leavedc -a actionagent -l $dc -u vea_agent@vea_domain.vx --no-prompt 2> /dev/null
}

osname=`uname`

if [ $osname = 'HP-UX' ] 
then
    if [[ $SW_SESSION_IS_DRD -ne 1 ]]
    then
      leavedom
    else
     leavedomDRD
    fi
else
   leavedom
fi


if [ $osname = "SunOS" ]
then
    PKG_AVAILABLE=`pkginfo VRTSmusfm 2>/dev/null`
    if [ $? -eq 0 ]
    then
        sh /opt/VRTSmusfm/bin/unsetup_catalog.sh 2>/dev/null
    fi
fi

### actionagent objecttypes.xml file
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ SECURITYFORMFILE 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ INTERFACEFORMFILE 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ SECURITYFORMDTD 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ OBJECTTYPEDTD 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ INTERFACEFORMDTD 2>/dev/null

$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME IMAGEFILE 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME ClIENTEXTENSION 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME TASK_LOGS 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME MessageCatalogs 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME/Registration Type 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/Providers/LeafRegistration IMAGEFILE 2>/dev/null

$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME/Registration 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Providers/LeafRegistration 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Providers 2>/dev/null
#$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/MessageCatalogs 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ProviderGroup 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Tracing/vxisis 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Tracing 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/SecuredManagers ManagerList 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/SecuredManagers 2>/dev/null

$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME INSTALLDIR 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME PERSISTENT_ID 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME Port 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME ProviderCount 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME SYSGROUPNODEPID 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME VERSION 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME InterfaceFormFile 2>/dev/null

### ActionAgent Groups entries
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Groups 2>/dev/null

## Action Agent Extension handling
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID SymbolicName 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 FLAGS 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 Version 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 IMAGEFILE 2>/dev/null


## Action Agent Extension handling
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID SymbolicName 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033 FLAGS 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033 Version 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033 IMAGEFILE 2>/dev/null

## Delete Message Catalog values
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033 FLAGS 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033 Version 2>/dev/null
$REGOPS $REGFILE deletevalue $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033 IMAGEFILE 2>/dev/null
## Delete Network releated keys 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Network/Params/Security 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Network/Params 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Network 2>/dev/null
## Delete client Extention releated key
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID 2>/dev/null

$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID 2>/dev/null


## Delete Message Catalog Releated Changes
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID 2>/dev/null

$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/Registration 2>/dev/null

$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/ClientExtensions 2>/dev/null
$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME/MessageCatalogs 2>/dev/null


$REGOPS $REGFILE deletekey $AGENTS/$AGENT_NAME 2>/dev/null




RM=/bin/rm

case $osname in
    "SunOS") rcdir=/etc;;
    "HP-UX") rcdir=/sbin;;
    "AIX")   rcdir=/etc/rc.d;;
    "Linux") rcdir=/etc;;
    *) rcdir=/etc;;
esac

if [ $osname = 'Linux' ] 
then
   /sbin/chkconfig --del vxpal.$AGENT_NAME > /dev/null
fi


$RM -f $VXAA_ETC/domain.cf 2>/dev/null


$RM -f $PKG_INSTALL_ROOT/$rcdir/init.d/vxpal.$AGENT_NAME
$RM -f $PKG_INSTALL_ROOT/$rcdir/rc2.d/S760vxpal.$AGENT_NAME
$RM -f $PKG_INSTALL_ROOT/$rcdir/rc2.d/K760vxpal.$AGENT_NAME
$RM -f $PKG_INSTALL_ROOT/$rcdir/rc1.d/K760vxpal.$AGENT_NAME
$RM -f $PKG_INSTALL_ROOT/$rcdir/rc0.d/K760vxpal.$AGENT_NAME
$RM -f $PKG_INSTALL_ROOT/$rcdir/rcS.d/K760vxpal.$AGENT_NAME

if [ $osname = 'AIX' ]
then
   rmitab $AGENT_NAME
fi

exit 0



