#!/bin/sh 
#$Id: setup_vxaa.in,v 1.33.6.2.2.2 2009/01/07 14:22:53 smalik Exp $
#$Copyright: Copyright (c) 2009 Symantec Corporation.
#All rights reserved.
#
#THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
#SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
#WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
#The Licensed Software and Documentation are deemed to be commercial
#computer software as defined in FAR 12.212 and subject to restricted
#rights as defined in FAR Section 52.227-19 "Commercial Computer
#Software - Restricted Rights" and DFARS 227.7202, "Rights in
#Commercial Computer Software or Commercial Computer Software
#Documentation", as applicable, and any successor regulations. Any use,
#modification, reproduction release, performance, display or disclosure
#of the Licensed Software and Documentation by the U.S. Government
#shall be solely in accordance with the terms of this Agreement.  $

############ Adding Registration Entries #############################
# Define keys

JUMPSTART_PATH="/"
if [ "X$PKG_INSTALL_ROOT" != "X" ]
then
    JUMPSTART_PATH="$PKG_INSTALL_ROOT"
fi


PALVERSION=pal33
AGENT_NAME=actionagent



REGFILE="$PKG_INSTALL_ROOT/etc/vx/isis/Registry"
REGOPS="$PKG_INSTALL_ROOT/opt/VRTSobc/$PALVERSION/bin/vxregctl"

OBC_INSTALLPATH="$PKG_INSTALL_ROOT/opt/VRTSobc" 
AGENT_INSTALLPATH="$PKG_INSTALL_ROOT/opt/VRTSaa"



OS=`uname -a`
OSSUFFIX=`uname -s`
AGENTS=Software/VERITAS/VRTSobc/$PALVERSION/Agents

VEACONFIG=$PKG_INSTALL_ROOT/opt/VRTSobc/pal33/bin/veaconfig


CE_ID={b0c6307c-d11e-46a8-8a33-82b599c20ee9}
MSGCAT_ID={3ddcb6cc-1dd2-11b2-bfb0-0003ba43f9b9}
HELP_ID={49f48010-1dd2-11b2-8433-0003ba919e6d}

#Add the keys to Registry

AGENT_ETC="$PKG_INSTALL_ROOT/opt/VRTSaa/etc"
OBC_ETC="$PKG_INSTALL_ROOT/opt/VRTSobc/$PALVERSION/etc"
AGENT_CONFIG="$PKG_INSTALL_ROOT/opt/VRTSaa/config"

mkdir -p /var$AGENT_ETC
touch /var$AGENT_ETC/domain.cf

if [ $OSSUFFIX = "HP-UX" ]
then
   LIFREGFILE=libleafregn.sl
   IMAGE_FILE=libactionagent.sl
   AP_IMAGE_FILE=libActionProvider200.sl.OFF
   TEP_IMAGE_FILE=libTEP120.sl.OFF
else
   LIFREGFILE=libleafregn.so
   IMAGE_FILE=libactionagent.so
   AP_IMAGE_FILE=libActionProvider200.so.OFF
   TEP_IMAGE_FILE=libTEP120.so.OFF
fi

#Error Codes
# WPAR compliance check #
if [ $OSSUFFIX != "AIX" ]
then
VXAA_MERGE_INTERFACE_FAILED=2
VXAA_MERGE_SECURITY_FAILED=3
fi # WPAR compliance check #
VXAA_REGISTRY_FAILED=4
VXAA_SECURITY_SETUP_FAILED=5



VXINTERFACE="$OBC_INSTALLPATH/$PALVERSION/bin/vxinterface"
VXSECAZ="$OBC_INSTALLPATH/$PALVERSION/bin/vxsecaz"
VXALERT="$OBC_INSTALLPATH/$PALVERSION/bin/vxalerttype"

# WPAR compliance check #
if [ $OSSUFFIX != "AIX" ]
then
ETCDIR="$PKG_INSTALL_ROOT/opt/VRTSaa/etc"

if [ ! -d $ETCDIR ]; then
        mkdir -p $ETCDIR
fi

merge_interface()
{
    if [ -f $PKG_INSTALL_ROOT/opt/VRTSaa/config/vxaa_intf.xml ]; then
        cp $OBC_INSTALLPATH/$PALVERSION/etc/interfaceform.dtd $ETCDIR/
        INPUT_FILE=$OBC_INSTALLPATH/$PALVERSION/etc/interfaceform.xml
        
        if [ -f $ETCDIR/interfaceform.xml ]; then
            INPUT_FILE=$ETCDIR/interfaceform.xml
        fi
        
        OUTPUT_FILE=$PKG_INSTALL_ROOT/tmp/interfaceform.xml.$$
        $VXINTERFACE -i $INPUT_FILE -o $OUTPUT_FILE -m $PKG_INSTALL_ROOT/opt/VRTSaa/config/vxaa_intf.xml
        
        if [ $? -ne 0 ]
        then
           return $VXAA_MERGE_INTERFACE_FAILED
        fi
        
        cp $OUTPUT_FILE $ETCDIR/interfaceform.xml
        rm -f $OUTPUT_FILE
    fi
    return 0; 
}

merge_security()
{
    if [ -f $PKG_INSTALL_ROOT/opt/VRTSaa/config/vxaa_security.xml ]; then
        cp $OBC_INSTALLPATH/$PALVERSION/etc/securityform.dtd $ETCDIR/
        INPUT_FILE=$OBC_INSTALLPATH/$PALVERSION/etc/securityform.xml
        if [ -f $ETCDIR/securityform.xml ]; then
            INPUT_FILE=$ETCDIR/securityform.xml
        fi
         OUTPUT_FILE=$PKG_INSTALL_ROOT/tmp/securityform.xml.$$

        $VXSECAZ -i $INPUT_FILE  -o $OUTPUT_FILE -m $PKG_INSTALL_ROOT/opt/VRTSaa/config/vxaa_security.xml
        if [ $? -ne 0 ]
        then
           return $VXAA_MERGE_SECURITY_FAILED
        fi
        cp $OUTPUT_FILE $ETCDIR/securityform.xml
        rm -f $OUTPUT_FILE
    fi
    return 0;
}
fi # WPAR compliance check #

disable_ap_tep()
{
   ISISDIR=$PKG_INSTALL_ROOT/opt/VRTSob
   PROV_DIR=$ISISDIR/providers/ActionProvider
   SIG_BIN_DIR=$ISISDIR/sig/bin
   SIG_MAP_DIR=$ISISDIR/sig/snmpmapfiles
   SIG_MIB_DIR=$ISISDIR/sig/snmpmibfiles
   MSGCAT_DIR=$ISISDIR/msgcats/ActionProvider/IsisSkin/Java/1033
   CE_DIR=$ISISDIR/extensions/ActionProvider/IsisSkin/Java
   CE_ENG_DIR=$ISISDIR/extensions/ActionProvider/IsisSkin/Java/1033
   
   REGFILE=$PKG_INSTALL_ROOT/etc/vx/isis/Registry
   
   CE_GUID='{7783bef0-6aa5-11d7-b4d5-00b0d0317df1}'
   CE_PROPERTIES_GUID='{77f96860-6aa5-11d7-b4d5-00b0d0317df1}'
   MC_GUID='{78306b20-6aa5-11d7-b4d5-00b0d0317df1}'
   HELP_GUID='{010ca9ef-5cdc-4d7b-97b4-9f2600ad1cc7}'
   
   PROV_KEY=Software/VERITAS/VxSvc/CurrentVersion/Providers/actionprovider
   SIG_KEY=Software/VERITAS/VxSvc/CurrentVersion/SIG
   
   CE_KEY_BASE="Software/VERITAS/VxSvc/CurrentVersion/ClientExtensions/$CE_GUID"
   CE_KEY_ENGLISH="$CE_KEY_BASE/IsisSkin/1/1033"
   
   CE_PROPERTIES_BASE="Software/VERITAS/VxSvc/CurrentVersion/ClientExtensions/$CE_PROPERTIES_GUID"
   CE_PROP_ENGLISH="$CE_PROPERTIES_BASE/IsisSkin/1/1033"
   
   MSGCAT_KEY_BASE="Software/VERITAS/VxSvc/CurrentVersion/MessageCatalogs/$MC_GUID"
   MSGCAT_KEY_ENGLISH="$MSGCAT_KEY_BASE/IsisSkin/1/1033"
   
   HELP_KEY_BASE="Software/VERITAS/VxSvc/CurrentVersion/ClientExtensions/$HELP_GUID"
   HELP_KEY_ENGLISH="$HELP_KEY_BASE/IsisSkin/1/1033"
   CURRENT_VERSION=Software/VERITAS/VxSvc/CurrentVersion
   


   $REGOPS $REGFILE deletekey $PROV_KEY 2>/dev/null
   $REGOPS $REGFILE deletekey $SIG_KEY 2>/dev/null

   # vxregctl doesn't recurse keys automatically, thus we have to be explicit
   $REGOPS $REGFILE deletekey "$CE_KEY_BASE/IsisSkin/1/1033" 2>/dev/null
   $REGOPS $REGFILE deletekey "$CE_KEY_BASE/IsisSkin/1" 2>/dev/null
   $REGOPS $REGFILE deletekey "$CE_KEY_BASE/IsisSkin" 2>/dev/null
   $REGOPS $REGFILE deletekey "$CE_KEY_BASE" 2>/dev/null

   $REGOPS $REGFILE deletekey "$HELP_KEY_BASE/IsisSkin/1/1033" 2>/dev/null
   $REGOPS $REGFILE deletekey "$HELP_KEY_BASE/IsisSkin/1" 2>/dev/null
   $REGOPS $REGFILE deletekey "$HELP_KEY_BASE/IsisSkin" 2>/dev/null
   $REGOPS $REGFILE deletekey "$HELP_KEY_BASE" 2>/dev/null

   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_ENGLISH" 2>/dev/null
   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_BASE/IsisSkin/1" 2>/dev/null
   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_BASE/IsisSkin" 2>/dev/null
   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_BASE" 2>/dev/null

   $REGOPS $REGFILE deletekey "$CE_PROP_ENGLISH" 2>/dev/null
   $REGOPS $REGFILE deletekey "$CE_PROPERTIES_BASE/IsisSkin/1" 2>/dev/null
   $REGOPS $REGFILE deletekey "$CE_PROPERTIES_BASE/IsisSkin" 2>/dev/null
   $REGOPS $REGFILE deletekey "$CE_PROPERTIES_BASE" 2>/dev/null

   ISISDIR=$PKG_INSTALL_ROOT/opt/VRTSob
   PROV_DIR=$ISISDIR/providers/TaskExec
   SIG_BIN_DIR=$ISISDIR/sig/bin
   MSGCAT_DIR=$ISISDIR/msgcats/TaskExec/IsisSkin/Java/1033
   CE_DIR=$ISISDIR/extensions/TaskExec/IsisSkin/Java

   VERSION_KEY=Software/VERITAS/TaskExec/v1.20.028
   PROV_KEY=Software/VERITAS/VxSvc/CurrentVersion/Providers/taskexec
   SIG_KEY=Software/VERITAS/VxSvc/CurrentVersion/SIG

   MSGCAT_KEY_BASE=Software/VERITAS/VxSvc/CurrentVersion/MessageCatalogs/\{F3C40F97-4519-BE53-FEEB7BA22E18\}
   MSGCAT_KEY_ENGLISH="$MSGCAT_KEY_BASE"/IsisSkin/1/1033

   $REGOPS $REGFILE deletekey $VERSION_KEY 2>/dev/null
   $REGOPS $REGFILE deletekey $PROV_KEY 2>/dev/null

   # vxregctl doesn't recurse keys automatically, thus we have to be explicit
   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_ENGLISH" 2>/dev/null
   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_BASE"/IsisSkin/1 2>/dev/null
   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_BASE"/IsisSkin  2>/dev/null
   $REGOPS $REGFILE deletekey "$MSGCAT_KEY_BASE"  2>/dev/null

}
setup_registry()
{
    DOI=`date +%D`

    $REGOPS $REGFILE createkey  $AGENTS/$AGENT_NAME/ 2>/dev/null
    $REGOPS $REGFILE setvalue   $AGENTS/$AGENT_NAME/ INSTALLDIR REG_SZ $AGENT_INSTALLPATH/ 2>/dev/null

    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ Port REG_INT 2150 2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ VERSION  REG_SZ 5.0.613.0  2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ Company  REG_SZ "Symantec Corporation"  2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ Copyright  REG_SZ "2008"  2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ Classification  REG_SZ "Veritas ActionAgent"  2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ Description  REG_SZ "Veritas Action Agent"  2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ UmiID  REG_SZ ""  2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ PSTAMP  REG_SZ ""  2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ InstallDate  REG_SZ $DOI  2>/dev/null

    #$REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/MessageCatalogs 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Groups 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ProviderGroup 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Providers 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Providers/LeafRegistration 2>/dev/null
    $REGOPS $REGFILE setvalue $AGENTS/$AGENT_NAME/Providers/LeafRegistration/ IMAGEFILE REG_SZ $OBC_INSTALLPATH/$PALVERSION/lib/$LIFREGFILE 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Registration/ 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Registration/ 2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Registration/ Type REG_SZ Agent 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/SecuredManagers/ 2>/dev/null
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/SecuredManagers/ ManagerList REG_SZ /opt/VRTSaa/etc/domain.cf 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Tracing/ 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Tracing/vxisis/ 2>/dev/null

    #Action Agent Provider Entries
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME IMAGEFILE REG_SZ /opt/VRTSaa/lib/$IMAGE_FILE
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME ClIENTEXTENSION REG_SZ $CE_ID
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME MessageCatalog REG_SZ $MSGCAT_ID
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME DATABASE REG_SZ /var/vx/VRTSaa/db
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME RULES_DB REG_SZ /var/vx/VRTSaa/db/rules.db
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME TRAP_DB REG_SZ /var/vx/VRTSaa/db/trap.db
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME SNMP_FILES REG_SZ /opt/VRTSaa/snmpfiles/
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME WIN_SNMP_FILES REG_SZ /opt/VRTSaa/win-snmpfiles/
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME EMAIL_CONF REG_SZ /var/vx/VRTSaa/db/email.conf
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME DOWNLOADS REG_SZ /var/vx/VRTSaa/downloads
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME FLAGS REG_INT 0
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME Configlets REG_SZ actionagentconfig 
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME TASK_LOGS REG_SZ /var/vx/VRTSaa/logs/default.log 

    #Registration Related Entries
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME/Registration
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/Providers/$AGENT_NAME/Registration Type REG_SZ Agent_Provider

    #Action Agent Group Entries
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Groups

    #Action Agent Extension Entries
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID SymbolicName REG_SZ ActionAgentISISExtension
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 FLAGS REG_INT 0
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 Version REG_SZ 5.0.613.0
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 IMAGEFILE REG_SZ /opt/VRTSaa/ext/IsisSkin/Java/1033/ActionAgentUI.jar
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 StrictDependsOn REG_SZ VxAAHelpCE
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$CE_ID/IsisSkin/1/1033 DependsOn REG_SZ VxAAResourceBundle
    
    
    #Action Agent Help Entries
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/ SymbolicName REG_SZ VxAAHelpCE
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033 FLAGS REG_INT 100
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033 Version REG_SZ 5.0.613.0
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/ClientExtensions/$HELP_ID/IsisSkin/1/1033 IMAGEFILE REG_SZ /opt/VRTSaa/ext/IsisSkin/Java/1033/VxAAHelp.jar
        
    #Action Agent Message Catalog Entries
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033 FLAGS REG_INT 0
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033 Version REG_SZ 5.0.613.0 
    $REGOPS $REGFILE setvalue  $AGENTS/$AGENT_NAME/MessageCatalogs/$MSGCAT_ID/IsisSkin/1/1033 IMAGEFILE REG_SZ /opt/VRTSaa/msgcat/IsisSkin/Java/1033/vxaa_cat_en.txt


    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Network 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Network/Params 2>/dev/null
    $REGOPS $REGFILE createkey $AGENTS/$AGENT_NAME/Network/Params/Security 2>/dev/null

    ##########################################################################################################
    ## actionagent  objecttypes.xml file
    $REGOPS $REGFILE setvalue $AGENTS/$AGENT_NAME/ SECURITYFORMFILE REG_SZ /opt/VRTSaa/etc/securityform.xml
    $REGOPS $REGFILE setvalue $AGENTS/$AGENT_NAME/ INTERFACEFORMFILE REG_SZ /opt/VRTSaa/etc/interfaceform.xml
    $REGOPS $REGFILE setvalue $AGENTS/$AGENT_NAME/ SECURITYFORMDTD REG_SZ /opt/VRTSaa/etc/securityform.dtd
    $REGOPS $REGFILE setvalue $AGENTS/$AGENT_NAME/ OBJECTTYPEDTD REG_SZ /opt/VRTSaa/etc/objecttypes.dtd
    $REGOPS $REGFILE setvalue $AGENTS/$AGENT_NAME/ INTERFACEFORMDTD REG_SZ /opt/VRTSaa/etc/interfaceform.dtd
    ##########################################################################################################
    if [ $OSSUFFIX = "SunOS" ]
    then
        setup_lp_registry
    fi
}

setup_lp_registry()
{
      PKG_AVAILABLE=`pkginfo VRTSmusfm 2>/dev/null`
      if [ $? -eq 0 ]
      then
        sh /opt/VRTSmusfm/bin/setup_catalog.sh
      fi
}

setup_security()
{
   AGENT_NAME=actionagent
   AGENT_PASSWD=$1;

   SECKEY=Software/VERITAS/VRTSobc/$PALVERSION/Agents/__defaults/Network/Params/Security

   q_hostname=`$OBC_INSTALLPATH/$PALVERSION/bin/vxregctl $REGFILE queryvalue $SECKEY LocalSystem 2>/dev/null`
   q_dc=`$OBC_INSTALLPATH/$PALVERSION/bin/vxregctl $REGFILE queryvalue $SECKEY DomainController 2>/dev/null`
   q_ab=`$OBC_INSTALLPATH/$PALVERSION/bin/vxregctl $REGFILE queryvalue $SECKEY AuthenticationBroker 2>/dev/null`

   hostname=`echo $q_hostname |sed -e 's/^.*: //g'`
   dc=`echo $q_dc |sed -e 's/^.*: //g'`
   ab=`echo $q_ab |sed -e 's/^.*: //g'`

   $VEACONFIG -b $JUMPSTART_PATH -c leavedc -a actionagent -l $dc -u vea_agent@vea_domain.vx --no-prompt 2> /dev/null

   $OBC_INSTALLPATH/$PALVERSION/install/cfgsecurity.sh -a $AGENT_NAME -h $hostname -d $hostname -p $AGENT_PASSWD -b $ab  2>/dev/null 2>&1
   if [ $? -ne 0 ]
   then
       echo "Security configuration for $AGENT_NAME agent failed"
       return $VXAA_SECURITY_SETUP_FAILED
   fi
}

setup_rc_files()
{
    osname=`uname`

    case $osname in
        "SunOS") rcdir=/etc;;
        "HP-UX") rcdir=/sbin;;
        "AIX")   rcdir=/etc/rc.d;;
        "Linux") rcdir=/etc;;
        *) rcdir=/etc;;
    esac

    script_name=$PKG_INSTALL_ROOT/$rcdir/init.d/vxpal.$AGENT_NAME
    Sscript_name=$PKG_INSTALL_ROOT/$rcdir/rc2.d/S760vxpal.$AGENT_NAME
    Kscript_name=$PKG_INSTALL_ROOT/$rcdir/rc2.d/K760vxpal.$AGENT_NAME
    Kscript_name_rc1=$PKG_INSTALL_ROOT/$rcdir/rc1.d/K760vxpal.$AGENT_NAME
    Kscript_name_rc0=$PKG_INSTALL_ROOT/$rcdir/rc0.d/K760vxpal.$AGENT_NAME
    Kscript_name_rcS=$PKG_INSTALL_ROOT/$rcdir/rcS.d/K760vxpal.$AGENT_NAME

    cp $AGENT_CONFIG/start$AGENT_NAME.sh $script_name

    chown root:sys $script_name
    chmod 0744 $script_name
    ln -s $script_name $Sscript_name >/dev/null 2>&1
    ln -s $script_name $Kscript_name >/dev/null 2>&1
    if [ $osname != "HP-UX" ]
    then
       ln -s $script_name $Kscript_name_rc1 >/dev/null 2>&1
       ln -s $script_name $Kscript_name_rc0 >/dev/null 2>&1
       ln -s $script_name $Kscript_name_rcS >/dev/null 2>&1
    fi

    if [ $osname = "AIX" ]
    then
      lsitab $AGENT_NAME >/dev/null 2>&1
      result=$?
      if [ "X$result" != "X0" ]
      then
        mkitab "$AGENT_NAME:2:once:$script_name"
      fi
    elif [ $osname = "Linux" ]
    then
        /sbin/chkconfig --add vxpal.$AGENT_NAME > /dev/null
        if [ $? -eq 1 ]
        then
          echo "Unable to update runlevel information for vxpal.$AGENT_NAME"
        fi
    fi
}
usage()
{
  echo "usage: $0 --nocpi <agent password> "
  echo "usage: $0 --cpi"
  exit 1
}

WITHOUT_CPI=NO
AGENT_PWD=""

mode=`$REGOPS $REGFILE queryvalue  Software/VERITAS/VRTSobc/$PALVERSION/Agents/__defaults Mode 2>/dev/null`
mode=`echo $mode |sed -e 's/^.*: //g'`
if [ "$mode" = 2 ]
then
    if [ $# -eq 1 ]
    then
        if [ $1 = "--cpi" ]
        then
            echo ""
        elif [ $1 = "--upgrade" ];then
           setup_registry
           exit 0
        else
        usage
   fi
elif [ $# -eq 2 ]
then
   if [ $1 = "--nocpi" ]
   then
     WITHOUT_CPI=YES
     AGENT_PWD=$2
   else
     usage
   fi
else
  usage
fi
fi

# WPAR compliance check #
if [ $OSSUFFIX != "AIX" ]
then
merge_interface  	 
if [ $? -ne 0 ] 	 
then 	 
 exit $VXAA_MERGE_INTERFACE_FAILED 	 
fi 	 
  	 
merge_security 	 
if [ $? -ne 0 ] 	 
then 	 
 exit $VXAA_MERGE_SECURITY_FAILED 	 
fi
fi # WPAR compliance check #

disable_ap_tep

setup_registry
if [ $? -ne 0 ]
then
    exit $VXAA_REGISTRY_FAILED
fi

if [ $WITHOUT_CPI = "YES" ]
then
    setup_security $AGENT_PWD
    if [ $? -ne 0 ]
    then
         exit $VXAA_SECURITY_SETUP_FAILED
    fi
fi


if [ "$mode" = 1 ]
then
   $OBC_INSTALLPATH/$PALVERSION/install/cfgsecurity.sh -a $AGENT_NAME 2>/dev/null 2>&1
fi

setup_rc_files
if [ $? -ne 0 ]
then
    exit $?
fi

exit 0








