#!/bin/sh
# $Id: startactionagent.sh,v 1.12.4.1 2008/10/24 10:42:40 gsinha Exp $
# $Copyright: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $

#chkconfig: 35 76 76
#description: VERITAS Stroage Foundation Action Agent (actionagent)

### BEGIN INIT INFO
# Provides:       vxpal.VRTSaa.actionagent
# Required-Start: isisd vxpbx_exchanged $network
# Required-Stop:
# Default-Start:  3 5
# Default-Stop:
#description: VERITAS Stroage Foundation Action Agent (actionagent)
### END INIT INFO

PATH=/usr/bin:/bin:$PATH
export PATH
PAL=pal33
VXPAL=/opt/VRTSobc/$PAL/bin/vxpal
AGENT_NAME=actionagent

OS=`uname`
SHUTDOWNMESSAGE="Stopping Veritas Enterprise Administrator action agent"
STARTMESSAGE="Starting Veritas Enterprise Administrator action agent"


if [ $OS = "SunOS" ]
then
   AWK_CMD=nawk
else
   AWK_CMD=awk
fi

VXAARUNSTATE=`echo " RUNNING"`
VXAANORUNSTATE=`echo " NOT RUNNING"`
VXAASTARTING=`echo " STARTING"`
VXAASTOPING=`echo " STOPPING"`

VXAASTARTMESSAGE="Starting actionagent ( VRTSaa)"
VXAASTARTSUCCESSMESSAGE="actionagent has successfully started"
VXAAFAILUREMESSAGE="actionagent has failed to start"
VXAASHUTDOWNMESSAGE="Stopping VEA actionagent Service (VRTSaa) "
VXAAFORCESHUTDOWN="VEA actionagent could not be stopped after 2 minutes. VEA actionagent will be stopped forcefully"

VXAAINSTANCERUNNING="An instance of actionagent is running. Please stop it before starting another instance."

VXAA_LOCK_FILE=/var/vx/isis/actionagent.lock

KILLAGENTCMD="$VXPAL -a $AGENT_NAME -c stop"
STATUSAGENTCMD="$VXPAL -a $AGENT_NAME -c status" 


WPARTEST=`uname -W 2>/dev/null`
if [ "X$WPARTEST" = "X0" ]
then
    GLOBALFLAG="-@ Global"
    PSARGS="-o uid,pid,args"
fi



vxaa_start_wait()
{
    echo $VXAASTARTMESSAGE
    i=0
    while [ "$i" != "3" ]
    do
       sleep 2
       printf "."
       i=`expr $i + 1`
    done
    CURRENT_RUNSTATE=`$VXPAL -a $AGENT_NAME -c status|$AWK_CMD -F: '{ print $2 }'`
    while [ "$VXAARUNSTATE" != "$CURRENT_RUNSTATE" -a "$VXAANORUNSTATE" != "$CURRENT_RUNSTATE" -a "" != "$CURRENT_RUNSTATE" ]
    do
        sleep 2
        printf "."
        CURRENT_RUNSTATE=`$VXPAL -a $AGENT_NAME -c status|$AWK_CMD -F: '{ print $2 }'`
    done
    if [ "$VXAARUNSTATE" = "$CURRENT_RUNSTATE" ]
    then
       echo $VXAASTARTSUCCESSMESSAGE
    else
       echo $VXAAFAILUREMESSAGE
    fi
}

vxaa_loop_wait()
{
    CURRENT_RUNSTATE=`$VXPAL -a $AGENT_NAME -c status|$AWK_CMD -F: '{ print $2 }'`
    while [ "$VXAASTARTING" = "$CURRENT_RUNSTATE" ]
    do
        sleep 1
        CURRENT_RUNSTATE=`$VXPAL -a $AGENT_NAME -c status|$AWK_CMD -F: '{ print $2 }'`
    done
    while [ "$VXAASTOPING" = "$CURRENT_RUNSTATE" ]
    do
        sleep 1
        CURRENT_RUNSTATE=`$VXPAL -a $AGENT_NAME -c status|$AWK_CMD -F: '{ print $2 }'`
    done
}

vxaa_start_service()
{
   vxaa_loop_wait
   if [ -f $VXAA_LOCK_FILE ]
   then
       PID=`cat $VXAA_LOCK_FILE`
       if [ "X$PID" = X ]
       then
           rm -f $VXAA_LOCK_FILE  2>/dev/null
           $VXPAL -a $AGENT_NAME >/dev/null 2>&1 </dev/null
           if [ "$1" = "wait" ]
           then
              vxaa_start_wait
           else
              echo $VXAASTARTMESSAGE
           fi
       else
           PROC=`ps -aef $GLOBALFLAG | grep vxpal | grep actionagent | grep -v status | grep -v vxpal.actionagent`
           if [ "X$PROC" = X ]
           then
               rm -f $VXAA_LOCK_FILE  2>/dev/null
               $VXPAL -a $AGENT_NAME >/dev/null 2>&1 </dev/null
               if [ "$1" = "wait" ]
               then
                  vxaa_start_wait
               else
                  echo $VXAASTARTMESSAGE
               fi
           else
               echo "$VXAAINSTANCERUNNING"
           fi
       fi
   else
       $VXPAL -a $AGENT_NAME >/dev/null 2>&1 </dev/null
       if [ "$1" = "wait" ]
       then
          vxaa_start_wait
       else
          echo $VXAASTARTMESSAGE
       fi
      
   fi
}

vxaa_stop_service()
{
   vxaa_loop_wait
   if [ "$VXAARUNSTATE " = "$CURRENT_RUNSTATE" ]
   then
        echo "$VXAASHUTDOWNMESSAGE"
        ($KILLAGENTCMD >/dev/null 2>&1 </dev/null &)
        PID=$!
        echo $STATUSAGENTCMD | $AWK_CMD '{
            for (i=0;i<30;i++)
            {
               $0 | getline output
               close($0)
               if (output ~ /NOT RUNNING/)
               {
                   break
               }
               else
               {
                   system("sleep 2");
                   printf ".";
               }
             }
             if (i == 30)
             {
                printf "\n";
             }
         }' 
         # now kill actionagent with a kill -9
         CURRENT_RUNSTATE=`$STATUSAGENTCMD|$AWK_CMD -F: '{ print $2 }'`
         if [ "$VXAASTOPING" = "$CURRENT_RUNSTATE" ]
         then
           echo "$VXAAFORCESHUTDOWN"
           kill -9 $PID 2>/dev/null
           PID=`eval ps -aef $GLOBALFLAG $PSARGS | $AWK_CMD '/'-a actionagent'/ && !/$AWK_CMD/ {print $2}'`
           kill -9 $PID 2>/dev/null
           rm -f /var/vx/isis/actionagent.lock 2>/dev/null
         fi
         echo $STOPSUCCESSMESSAGE
      fi
      rm -f /var/vx/isis/actionagent.lock 2>/dev/null
}

if [ "X$OS" = "XHP-UX" ]
then
	case "$1" in
    	start)
        	vxaa_start_service $2
        	;;
    	stop)
        	vxaa_stop_service
        	;;
	'start_msg')
		echo "$STARTMESSAGE"
		;;
	'stop_msg')
		echo "$SHUTDOWNMESSAGE"
		;;
	'status')
		$VXPAL -a $AGENT_NAME -c status
		;;
	'version')
		$VXPAL -v
		;;
    	restart)
        	vxaa_stop_service
        	vxaa_start_service $2
        	;;
    	*)
        	echo "Usage: /etc/init.d/vxpal.actionagent { start | stop | restart }"
        	exit 1
        	;;
	esac
else
	case "$1" in
    	start)
        	vxaa_start_service $2
        	;;
    	stop)
        	vxaa_stop_service
        	;;
    	restart)
        	vxaa_stop_service
        	vxaa_start_service $2
        	;;
    	*)
        	echo "Usage: /etc/init.d/vxpal.actionagent { start | stop | restart }"
        	exit 1
        	;;
	esac
fi

exit 0

