#!/bin/sh

# $Id: startgridcentral.sh,v 1.8.20.1 2008/10/24 10:42:39 gsinha Exp $ 
# $Copyrights: Copyright (c) 2009 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $

#chkconfig: 35 75 75
#description: VERITAS Central Control Grid (gridcentral)

### BEGIN INIT INFO
# Provides:       vxpal.VRTSccg.gridcentral
# Required-Start: vxpbx_exchanged $network
# Required-Stop:
# Default-Start:  3 5
# Default-Stop:
# Description:    VERITAS Central Control Grid (gridcentral)
### END INIT INFO

PATH=/usr/bin:/bin:$PATH
export PATH

AGENT_NAME=gridcentral
PAL=pal33
VXPAL=/opt/VRTSobc/$PAL/bin/vxpal
VXPALCTRL=/opt/VRTSobc/$PAL/bin/vxpalctrl
OS=`uname`
SHUTDOWNMESSAGE="Stopping Veritas Enterprise Administrator gridcentral agent"
STARTMESSAGE="Starting Veritas Enterprise Administrator gridcentral agent"


if [ ! -x $VXPAL ]
then
	echo "ERROR:    $VXPAL not found"
	exit 1
fi

if [ "X$OS" = "XHP-UX" ]
then
	case "$1" in
		'start')
			$VXPAL -a $AGENT_NAME
			;;
		'stop')
			$VXPALCTRL -a $AGENT_NAME -c stop
			;;
		'start_msg')
			echo "$STARTMESSAGE"
			;;
		'stop_msg')
			echo "$SHUTDOWNMESSAGE"
			;;
		'status')
			$VXPAL -a $AGENT_NAME -c status
			;;
		'version')
			$VXPAL -v
			;;
		'restart')
			$VXPAL -a $AGENT_NAME -c restart
			;;
		*)
			echo "Usage:   $0 { start | stop }"
			exit 1
			;;
	esac
else
	case "$1" in
		'start')
			echo "NOTE:    Starting VERITAS $AGENT_NAME"
			$VXPAL -a $AGENT_NAME
			;;
		'stop')
			echo "NOTE:    Stopping VERITAS $AGENT_NAME"
			$VXPALCTRL -a $AGENT_NAME -c stop
			;;
		*)
			echo "Usage:   $0 { start | stop }"
			exit 1
			;;
	esac
fi

exit 0
