/* $Id: policy_delete.c,v 4.2 2006/03/17 15:26:23 phils Exp $  */
/* #ident "@(#)vxfs:$RCSfile: policy_delete.c,v $	$Revision: 4.2 $" */

/*
 * $Copyright: Copyright (c) 2009 Symantec Corporation.
 * All rights reserved.
 *
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
 * SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
 * WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
 *
 * The Licensed Software and Documentation are deemed to be commercial
 * computer software as defined in FAR 12.212 and subject to restricted
 * rights as defined in FAR Section 52.227-19 "Commercial Computer
 * Software - Restricted Rights" and DFARS 227.7202, "Rights in
 * Commercial Computer Software or Commercial Computer Software
 * Documentation", as applicable, and any successor regulations. Any use,
 * modification, reproduction release, performance, display or disclosure
 * of the Licensed Software and Documentation by the U.S. Government
 * shall be solely in accordance with the terms of this Agreement.  $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <mntent.h>

#include <string.h>
#include <stdint.h>
#include <time.h>
#include <vxfsutil.h>

int
main(
	int	argc,
	char	**argv)
{
	struct fsap_info	ap;
	int			i, count, fd, error, rtn=0;
	struct fsap_info	*infop;
	struct mntent		*mp;
	FILE			*fpmnt;
	int			entry_found = 0;

	count = 100;
	if ((infop = (struct fsap_info *) malloc(sizeof(struct fsap_info)
							 * count)) == NULL) {
		printf("\n Fatal error, unable to malloc()");
		exit(1);
	}

	fpmnt = setmntent(MNTTAB, "r");
	if (!fpmnt) {
		printf("\nUnable to open mount table");
		exit(1);
	}
	while ((mp = getmntent(fpmnt)) != NULL) {

		if (strcmp(mp->mnt_type, "vxfs") != 0)
			continue;

		if ((fd = open(mp->mnt_dir, O_RDONLY)) < 0)
			continue;
		count = 100;
		memset(infop, 0, sizeof(struct fsap_info) * count);
		if ((error = vxfs_ap_enumerate(fd, &count, infop)) != 0) {

			printf(" find devd %s", strerror(error));
			close(fd);
			rtn = 1;
			continue;
		} else {
			for (i = 0; i < count; i++) {

				/*
				 * delete allocation policy
				 */

				if (strncmp(infop[i].ap_name, "sdk_", 4))
					continue;
				if (error =
				    vxfs_ap_remove(fd, infop[i].ap_name) != 0) {
					printf(" \nError  removing policy, %s",
					       strerror(error));
					  rtn = 1;
				} else {
					printf("\nRemoved Policy %s from FS %s",
					infop[i].ap_name, mp->mnt_dir);
				}
			}
		}
		close(fd);
	}
	free(infop);
	exit(rtn);
}
