/* $Id: policy_display.c,v 4.2 2006/03/17 15:26:24 phils Exp $  */
/* #ident "@(#)vxfs:$RCSfile: policy_display.c,v $	$Revision: 4.2 $" */

/*
 * $Copyright: Copyright (c) 2009 Symantec Corporation.
 * All rights reserved.
 *
 * THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
 * SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
 * WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
 *
 * The Licensed Software and Documentation are deemed to be commercial
 * computer software as defined in FAR 12.212 and subject to restricted
 * rights as defined in FAR Section 52.227-19 "Commercial Computer
 * Software - Restricted Rights" and DFARS 227.7202, "Rights in
 * Commercial Computer Software or Commercial Computer Software
 * Documentation", as applicable, and any successor regulations. Any use,
 * modification, reproduction release, performance, display or disclosure
 * of the Licensed Software and Documentation by the U.S. Government
 * shall be solely in accordance with the terms of this Agreement.  $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <mntent.h>
#include <errno.h>

#include <string.h>
#include <stdint.h>
#include <time.h>
#include <vxfsutil.h>

STATIC char    *vol_order[] = {
	"FSAP_ORDER_ASGIVEN",
	"FSAP_ORDER_LEASTFULL",
	"FSAP_ORDER_ROUNDROBIN",
};

int
main(
	int	argc,
	char	**argv)
{
	struct fsap_info	*infop;
	char			*path;
	int			i, j, fd, count, error = 0;
	struct mntent		*mp;
	FILE			*fpmnt;
	int			entry_found = 0;

	count = 100;
	if ((infop = (struct fsap_info *) malloc(sizeof(struct fsap_info)
							* count)) == NULL) {
		printf("\n fatal error, unable to malloc() ");
		exit(1);
	}

	fpmnt = setmntent(MNTTAB, "r");
	if (!fpmnt) {
		printf("\nUnable to open mount table");
		exit(1);
	}
	while ((mp = getmntent(fpmnt)) != NULL) {

		if (strcmp(mp->mnt_type, "vxfs") != 0)
			continue;

		if ((fd = open(mp->mnt_dir, O_RDONLY)) < 0)
			continue;
		count = 100;
		memset(infop, 0, sizeof(struct fsap_info) * count);
		if (((error = vxfs_ap_enumerate(fd, &count, infop)) != 0) &&
		    (error != E2BIG)) {

			/*
			 * error == E2BIG then we should really reread
			 * and get all the policies
			 */

			printf(" find devd %s", strerror(error));
			close(fd);
			continue;
		} else {
			for (i = 0; i < count; i++) {
				printf("\nFile System Name %s,"
					" Policy Name ( %s ) ",
					mp->mnt_dir, infop[i].ap_name);
				printf("\n\tflags: 0x%x", infop[i].ap_flags);
				printf("\n\torder: %s",
				       vol_order[infop[i].ap_order]);
				printf("\n\tndevs: %d", infop[i].ap_ndevs);
				printf("\n\tVolumes:");
				for (j = 0; j < infop[i].ap_ndevs; j++) {
					printf(" %s", infop[i].ap_devs[j]);
				}
			}

		}
		close(fd);
	}
	printf("\n");
	free(infop);
	exit(error);
}
